Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/Makefile.deps	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/Makefile.deps	(revision 75)
@@ -13,15 +13,10 @@
 include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
 endif
-ifndef Group
-include 			$(DIR_MORPHEO)/Behavioural/Generic/Group/Makefile.deps
-endif
 
 #-----[ Library ]------------------------------------------
 Victim_Pseudo_LRU_LIBRARY		= 	-lVictim_Pseudo_LRU		\
-						$(Group_LIBRARY)		\
 						$(Behavioural_LIBRARY)	
 
 Victim_Pseudo_LRU_DIR_LIBRARY		=	-L$(DIR_MORPHEO)/Behavioural/Generic/Victim/Victim_Pseudo_LRU/lib	\
-						$(Group_DIR_LIBRARY)							\
 						$(Behavioural_DIR_LIBRARY)	
 
@@ -31,10 +26,8 @@
 				@\
 				$(MAKE)  Behavioural_library; \
-				$(MAKE)  Group_library; \
 				$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Generic/Victim/Victim_Pseudo_LRU --makefile=Makefile;
-				
+
 Victim_Pseudo_LRU_library_clean	:
 				@\
 				$(MAKE)  Behavioural_library_clean; \
-				$(MAKE)  Group_library_clean; \
 				$(MAKE) --directory=$(DIR_MORPHEO)/Behavioural/Generic/Victim/Victim_Pseudo_LRU --makefile=Makefile clean;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/SelfTest/src/test.cpp	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/SelfTest/src/test.cpp	(revision 75)
@@ -36,9 +36,14 @@
       exit (EXIT_FAILURE);
     }
+
+#ifdef STATISTICS
+  morpheo::behavioural::Parameters_Statistics * param_stat = new morpheo::behavioural::Parameters_Statistics(5,50);
+#endif
+
   Victim_Pseudo_LRU * _Victim_Pseudo_LRU = new Victim_Pseudo_LRU (name.c_str(),
 #ifdef STATISTICS
-					     morpheo::behavioural::Parameters_Statistics(5,50),
-#endif
-					     param);
+								  param_stat,
+#endif
+								  param);
   
 #ifdef SYSTEMC
@@ -207,3 +212,8 @@
 
   delete _Victim_Pseudo_LRU;
+
+#ifdef STATISTICS
+  delete param_stat;
+#endif
+
 }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Parameters.h	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Parameters.h	(revision 75)
@@ -35,9 +35,8 @@
   public : ~Parameters () ;
 
-  public : string msg_error (void);
-
-  public :        string   print      (uint32_t depth);
-  public : friend ostream& operator<< (ostream& output_stream,
-				       morpheo::behavioural::generic::victim::victim_pseudo_lru::Parameters & x);
+  public :        std::string   msg_error  (void);
+  public :        std::string   print      (uint32_t depth);
+  public : friend std::ostream& operator<< (std::ostream& output_stream,
+					    morpheo::behavioural::generic::victim::victim_pseudo_lru::Parameters & x);
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Statistics.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Statistics.h	(revision 68)
+++ 	(revision )
@@ -1,59 +1,0 @@
-#ifdef STATISTICS
-#ifndef morpheo_behavioural_generic_victim_victim_pseudo_lru_Statistics_h
-#define morpheo_behavioural_generic_victim_victim_pseudo_lru_Statistics_h
-
-/*
- * $Id$
- *
- * [ Description ]
- * 
- */
-
-#include "Behavioural/include/Statistics.h"
-#include "Behavioural/include/Parameters_Statistics.h"
-#include "Behavioural/Generic/Group/include/Statistics.h"
-#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Parameters.h"
-
-using namespace morpheo::behavioural::generic::group;
-
-namespace morpheo                    {
-namespace behavioural {
-namespace generic {
-namespace victim {
-namespace victim_pseudo_lru {
-
-
-  class Statistics : public morpheo::behavioural::Statistics
-  {
-    // -----[ fields ]----------------------------------------------------
-  private  : const Parameters                                   _parameters;
-  private  : morpheo::behavioural::generic::group::Statistics * _stat_port_access;
-  private  : morpheo::behavioural::generic::group::Statistics * _stat_port_update;
-
-    // -----[ methods ]---------------------------------------------------
-  public   : Statistics  (string                                      name                       ,
-			  morpheo::behavioural::Parameters_Statistics parameters_statistics      ,
-			  Parameters                                  parameters
-			  );
-//public   : Statistics  (Statistics & stat);
-  public   : ~Statistics () ;
-    
-  public   : string   print_body (uint32_t depth);
-  public   : string   print      (uint32_t depth);
-  public   : void     add        (uint32_t nb_access ,
-				  uint32_t nb_update );
-    
-  public   : friend ostream& operator<< (ostream& output_stream,
-					 const Statistics & x);
-
-  };
-
-}; // end namespace victim_pseudo_lru
-}; // end namespace victim
-}; // end namespace generic
-
-}; // end namespace behavioural
-}; // end namespace morpheo
-
-#endif
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Types.h	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Types.h	(revision 75)
@@ -9,5 +9,5 @@
  */
 
-#include "Common/include/Types.h"
+#include "Behavioural/include/Types.h"
 
 namespace morpheo {
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h	(revision 75)
@@ -35,16 +35,10 @@
 #include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Types.h"
 #ifdef STATISTICS
-#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Statistics.h"
+#include "Behavioural/include/Stat.h"
 #endif
 #ifdef VHDL
 #include "Behavioural/include/Vhdl.h"
 #endif
-#ifdef POSITION
 #include "Behavioural/include/Component.h"
-#else
-#include "Behavioural/include/Interfaces.h"
-#endif
-
-using namespace std;
 
 namespace morpheo {
@@ -157,7 +151,7 @@
     }
 
-  public : string print ()
-    {
-      string res = "";
+  public : std::string print ()
+    {
+      std::string res = "";
 
       for (int32_t i=static_cast<int32_t>(_size)-1; i>=0; i--)
@@ -170,14 +164,12 @@
     // -----[ fields ]----------------------------------------------------
     // Parameters
-  protected : const string     _name;
+  protected : const std::string     _name;
 
   protected : const Parameters _param;
 #ifdef STATISTICS
-  private   : Statistics                     * _stat;
-#endif
-
-#ifdef POSITION
-  private   : Component                      * _component;
-#endif
+  public    : Stat                           * _stat;
+#endif
+
+  public    : Component                      * _component;
   private   : Interfaces                     * _interfaces;
 
@@ -215,12 +207,12 @@
   public  :          Victim_Pseudo_LRU              (
 #ifdef SYSTEMC
-					      sc_module_name                              name,
+					      sc_module_name                                name,
 #else					       
-					      string                                      name,
+					      std::string                                   name,
 #endif					       
 #ifdef STATISTICS
-					      morpheo::behavioural::Parameters_Statistics param_statistics,
-#endif
-					      Parameters                                  param );
+					      morpheo::behavioural::Parameters_Statistics * param_statistics,
+#endif
+					      Parameters                                    param );
 					       
   public  :          Victim_Pseudo_LRU              (Parameters param );
@@ -233,7 +225,4 @@
   public  : void     transition                (void);
   public  : void     genMealy_access           (void);
-#endif					       
-#ifdef STATISTICS
-  public  : string   statistics                (uint32_t depth);
 #endif
 					       
@@ -244,8 +233,11 @@
 #endif					       
 					       
-#ifdef VHDL_TESTBENCH			       
-  private : void     vhdl_testbench_transition (void);
-#endif
-
+#ifdef STATISTICS
+  public  : void     statistics_declaration    (morpheo::behavioural::Parameters_Statistics * param_statistics);
+#endif
+
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+  private : void     end_cycle                 (void);
+#endif
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters_msg_error.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters_msg_error.cpp	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters_msg_error.cpp	(revision 75)
@@ -9,5 +9,4 @@
 #include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Types.h"
 #include <sstream>
-using namespace std;
 
 namespace morpheo {
@@ -17,7 +16,7 @@
 namespace victim_pseudo_lru {
 
-  string Parameters::msg_error(void)
+  std::string Parameters::msg_error(void)
   {
-    string msg = "";
+    std::string msg = "";
 
     if (_nb_entity < 2)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters_print.cpp	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Parameters_print.cpp	(revision 75)
@@ -2,11 +2,11 @@
  * $Id$
  *
- * [ Description ]
+ * [ Description ]
  * 
  */
 
 #include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Parameters.h"
+#include "Behavioural/include/XML.h"
 #include <sstream>
-using namespace std;
 
 namespace morpheo {
@@ -16,20 +16,20 @@
 namespace victim_pseudo_lru {
 
-  string Parameters::print (uint32_t depth)
+  std::string Parameters::print (uint32_t depth)
   {
-    string tab = string(depth,'\t');
-    ostringstream msg;
-    msg << tab << "<victim_pseudo_lru>" << endl
-	<< tab << "\t<nb_entity  value=\"" << _nb_entity  << "\" />" << endl
-	<< tab << "\t<nb_access  value=\"" << _nb_access  << "\" />" << endl
-	<< tab << "\t<nb_update  value=\"" << _nb_update  << "\" />" << endl
-	<< tab << "\t<size_table value=\"" << _size_table << "\" />" << endl
-	<< tab << "</victim_pseudo_lru>" << endl;
-    
-    return msg.str();
+    XML xml ("victim_pseudo_lru");
+
+    xml.balise_open("victim_pseudo_lru");
+    xml.singleton_begin("nb_entity "); xml.attribut("value",toString(_nb_entity )); xml.singleton_end();
+    xml.singleton_begin("nb_access "); xml.attribut("value",toString(_nb_access )); xml.singleton_end();
+    xml.singleton_begin("nb_update "); xml.attribut("value",toString(_nb_update )); xml.singleton_end();
+    xml.singleton_begin("size_table"); xml.attribut("value",toString(_size_table)); xml.singleton_end();
+    xml.balise_close();
+
+    return xml.get_body(depth);
   };
 
-  ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::generic::victim::victim_pseudo_lru::Parameters & x)
+  std::ostream& operator<< (std::ostream& output_stream ,
+			    morpheo::behavioural::generic::victim::victim_pseudo_lru::Parameters & x)
   {
     output_stream << x.print(0);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics.cpp	(revision 68)
+++ 	(revision )
@@ -1,46 +1,0 @@
-#ifdef STATISTICS
-/*
- * $Id$
- *
- * [ Description ]
- * 
- */
-
-#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Statistics.h"
-
-namespace morpheo                    {
-namespace behavioural {
-namespace generic {
-namespace victim {
-namespace victim_pseudo_lru {
-
-
-  Statistics::Statistics (string                                      name                       ,
-			  morpheo::behavioural::Parameters_Statistics parameters_statistics      ,
-			  Parameters                                  parameters
-			  ) :
-    morpheo::behavioural::Statistics(name                  ,
-				     parameters_statistics ),
-    _parameters(parameters)
-  {
-    _stat_port_access = new morpheo::behavioural::generic::group::Statistics (name + "_port_access" ,
-									      parameters_statistics ,
-									      morpheo::behavioural::generic::group::Parameters(_parameters._nb_access));
-    _stat_port_update = new morpheo::behavioural::generic::group::Statistics (name + "_port_update"   ,
-									      parameters_statistics ,
-									      morpheo::behavioural::generic::group::Parameters(_parameters._nb_update));
-  };
-  
-  Statistics::~Statistics () 
-  { 
-    delete _stat_port_access;
-    delete _stat_port_update;
-  };
-
-}; // end namespace victim_pseudo_lru
-}; // end namespace victim
-}; // end namespace generic
-
-}; // end namespace behavioural
-}; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics_add.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics_add.cpp	(revision 68)
+++ 	(revision )
@@ -1,32 +1,0 @@
-#ifdef STATISTICS
-/*
- * $Id$
- *
- * [ Description ]
- * 
- */
-
-#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Statistics.h"
-
-#include <sstream>
-using namespace std;
-
-namespace morpheo {
-namespace behavioural {
-namespace generic {
-namespace victim {
-namespace victim_pseudo_lru {
-
-  void Statistics::add (uint32_t nb_access,
-			uint32_t nb_update)
-  {
-    _stat_port_access->add(nb_access);
-    _stat_port_update->add(nb_update);
-  };
-
-}; // end namespace victim_pseudo_lru
-}; // end namespace victim
-}; // end namespace generic
-}; // end namespace behavioural
-}; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics_print.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics_print.cpp	(revision 68)
+++ 	(revision )
@@ -1,47 +1,0 @@
-#ifdef STATISTICS
-/*
- * $Id$
- *
- * [ Description ]
- * 
- */
-
-#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Statistics.h"
-
-#include <sstream>
-using namespace std;
-
-namespace morpheo                    {
-namespace behavioural {
-namespace generic {
-namespace victim {
-namespace victim_pseudo_lru {
-
-
-  string Statistics::print (uint32_t depth)
-  {
-    string        tab = string(depth,'\t');
-    ostringstream msg;
-
-    msg << tab << "<victim_pseudo_lru name=\"" << _name << "\" >" << endl
-	<< print_body (depth+1)
-	<< tab << "</victim_pseudo_lru>" << endl;
-    
-    return msg.str();
-  };
-
-  ostream& operator<< (ostream& output_stream ,
-		       morpheo::behavioural::generic::victim::victim_pseudo_lru::Statistics & x)
-  {
-    output_stream << x.print(0);
-
-    return output_stream;
-  };
-
-}; // end namespace victim_pseudo_lru
-}; // end namespace victim
-}; // end namespace generic
-
-}; // end namespace behavioural
-}; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics_print_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Statistics_print_body.cpp	(revision 68)
+++ 	(revision )
@@ -1,38 +1,0 @@
-#ifdef STATISTICS
-/*
- * $Id$
- *
- * [ Description ]
- * 
- */
-
-#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Statistics.h"
-
-#include <sstream>
-using namespace std;
-
-namespace morpheo                    {
-namespace behavioural {
-namespace generic {
-namespace victim {
-namespace victim_pseudo_lru {
-
-
-  string Statistics::print_body (uint32_t depth)
-  {
-    string        tab = string(depth,'\t');
-    ostringstream msg;
-
-    msg << _stat_port_access->print(depth+1);
-    msg << _stat_port_update->print(depth+1);
-    
-    return msg.str();
-  };
-
-}; // end namespace victim_pseudo_lru
-}; // end namespace victim
-}; // end namespace generic
-
-}; // end namespace behavioural
-}; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU.cpp	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU.cpp	(revision 75)
@@ -17,8 +17,8 @@
   Victim_Pseudo_LRU::Victim_Pseudo_LRU (sc_module_name name,
 #else
-  Victim_Pseudo_LRU::Victim_Pseudo_LRU (string name,
+  Victim_Pseudo_LRU::Victim_Pseudo_LRU (std::string name,
 #endif
 #ifdef STATISTICS
-			  morpheo::behavioural::Parameters_Statistics             param_statistics,
+			  morpheo::behavioural::Parameters_Statistics * param_statistics,
 #endif
 			  morpheo::behavioural::generic::victim::victim_pseudo_lru::Parameters param ):
@@ -37,7 +37,5 @@
     
     // Allocation of statistics
-    _stat = new Statistics (static_cast<string>(_name),
-			    param_statistics          ,
-			    param);
+    statistics_declaration(param_statistics);
 #endif
 
@@ -93,6 +91,4 @@
 
 #ifdef STATISTICS
-    _stat->generate_file(statistics(0));
-    
     delete _stat;
 #endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_allocation.cpp	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_allocation.cpp	(revision 75)
@@ -17,19 +17,22 @@
   void Victim_Pseudo_LRU::allocation (void)
   {
-#ifdef POSITION
     _component   = new Component ();
 
-    Entity * entity = _component->set_entity (_name                  ,
-					     "Select_Priority_Fixed",
-					     COMBINATORY            );
+    Entity * entity = _component->set_entity (_name                  
+					      ,"Select_Priority_Fixed"
+#ifdef POSITION
+					      ,COMBINATORY           
+#endif
+					      );
     
     _interfaces = entity->set_interfaces();
-#else
-    _interfaces = new Interfaces();
-#endif
 
     // ~~~~~[ Interface : "" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
     {
-      Interface_fifo * interface = _interfaces->set_interface("", IN  ,WEST, "Generalist interface");
+      Interface_fifo * interface = _interfaces->set_interface(""
+#ifdef POSITION
+							      , IN  ,WEST, "Generalist interface"
+#endif
+							      );
       
       in_CLOCK        = interface->set_signal_clk              ("clock" ,1);
@@ -47,5 +50,9 @@
       for (uint32_t i=0; i<_param._nb_access; i++)
 	{
-	  Interface_fifo * interface = _interfaces->set_interface("access_"+toString(i), IN  ,WEST, "Access");
+	  Interface_fifo * interface = _interfaces->set_interface("access_"+toString(i)
+#ifdef POSITION
+								  , IN  ,WEST, "Access"
+#endif
+								  );
 
 	   in_ACCESS_VAL     [i] = interface->set_signal_valack_in        ("val"    , VAL);
@@ -69,5 +76,9 @@
       for (uint32_t i=0; i<_param._nb_update; i++)
 	{
-	  Interface_fifo * interface = _interfaces->set_interface("update_"+toString(i), IN  ,EAST, "Update");
+	  Interface_fifo * interface = _interfaces->set_interface("update_"+toString(i)
+#ifdef POSITION
+								  , IN  ,EAST, "Update"
+#endif
+								  );
 
  	  in_UPDATE_VAL     [i] = interface->set_signal_valack_in        ("val"    , VAL);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_end_cycle.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_end_cycle.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_end_cycle.cpp	(revision 75)
@@ -0,0 +1,41 @@
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
+
+namespace morpheo {
+namespace behavioural {
+namespace generic {
+namespace victim {
+namespace victim_pseudo_lru {
+
+#undef  FUNCTION
+#define FUNCTION "Victim_Pseudo_LRU::end_cycle"
+void Victim_Pseudo_LRU::end_cycle ()
+  {
+    log_printf(FUNC,Victim_Pseudo_LRU,FUNCTION,"Begin");
+
+#ifdef STATISTICS
+    _stat->end_cycle();
+#endif    
+
+#ifdef VHDL_TESTBENCH
+    // Evaluation before read the ouput signal
+//  sc_start(0);
+    _interfaces->testbench();
+#endif
+
+    log_printf(FUNC,Victim_Pseudo_LRU,FUNCTION,"End");
+  };
+
+}; // end namespace victim_pseudo_lru
+}; // end namespace victim
+}; // end namespace generic
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_statistics.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_statistics.cpp	(revision 68)
+++ 	(revision )
@@ -1,28 +1,0 @@
-#ifdef STATISTICS
-/*
- * $Id$
- *
- * [ Description ]
- * 
- */
-
-#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
-
-namespace morpheo                    {
-namespace behavioural {
-namespace generic {
-namespace victim {
-namespace victim_pseudo_lru {
-
-  
-  string Victim_Pseudo_LRU::statistics (uint32_t depth)
-  {
-    return _stat->print(depth);
-  };
-
-}; // end namespace victim_pseudo_lru
-}; // end namespace victim
-}; // end namespace generic
-}; // end namespace behavioural
-}; // end namespace morpheo              
-#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_statistics_declaration.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_statistics_declaration.cpp	(revision 75)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_statistics_declaration.cpp	(revision 75)
@@ -0,0 +1,35 @@
+#ifdef STATISTICS
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
+
+namespace morpheo                    {
+namespace behavioural {
+namespace generic {
+namespace victim {
+namespace victim_pseudo_lru {
+
+#undef  FUNCTION
+#define FUNCTION "Victim_Pseudo_LRU::statistics_declaration"
+  void Victim_Pseudo_LRU::statistics_declaration (morpheo::behavioural::Parameters_Statistics * param_statistics)
+  {
+    log_printf(FUNC,Victim_Pseudo_LRU,FUNCTION,"Begin");
+
+    _stat = new Stat (static_cast<std::string>(_name),
+		      "Victim_Pseudo_LRU",
+		      param_statistics);
+    
+    log_printf(FUNC,Victim_Pseudo_LRU,FUNCTION,"End");
+  };
+
+}; // end namespace victim_pseudo_lru
+}; // end namespace victim
+}; // end namespace generic
+}; // end namespace behavioural
+}; // end namespace morpheo              
+#endif
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_transition.cpp	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_transition.cpp	(revision 75)
@@ -61,11 +61,6 @@
       }//end for i
 
-#ifdef STATISTICS
-    _stat->add(_stat_nb_access,
-	       _stat_nb_update);
-#endif    
-    
-#ifdef VHDL_TESTBENCH
-    vhdl_testbench_transition ();
+#if defined(STATISTICS) or defined(VHDL_TESTBENCH)
+    end_cycle ();
 #endif
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_body.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_body.cpp	(revision 68)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_body.cpp	(revision 75)
@@ -40,5 +40,5 @@
 	// Read the table
 	
-	string access_address;
+	std::string access_address;
 
 	if (_param._size_table>1)
@@ -58,5 +58,5 @@
 	    for (int32_t k=(1<<j)-1; k<static_cast<int32_t>(_param._nb_entity-1); k+=(1<<(j+1)))
 	      {
-		string cond = "";
+		std::string cond = "";
 		
 		// Create the condition
@@ -70,5 +70,5 @@
 		  }
 		
-		string print_else = (k==(1<<j)-1)?"     ":"else ";
+		std::string print_else = (k==(1<<j)-1)?"     ":"else ";
 
 		vhdl->set_body ("\t"+print_else+"access_entry_"+toString(i)+"("+toString(k)+") "+cond);
@@ -93,5 +93,5 @@
 	    {
 	      bool   have_cond = false;
-	      string cond      = "";
+	      std::string cond      = "";
 	      
 	      // condition to change the bit
@@ -126,5 +126,5 @@
 	    {
 	      bool   have_cond = false;
-	      string cond      = "";
+	      std::string cond      = "";
 	      
 	      // condition to change the bit
@@ -144,5 +144,5 @@
 	      if (have_cond == true)
 		{
-		  string update_address;
+		  std::string update_address;
 
 		  if (_param._size_table>1)
@@ -170,5 +170,5 @@
     for (uint32_t i=0; i<_param._nb_access; i++)
       {
-	string access_address;
+	std::string access_address;
 
 	if (_param._size_table>1)
@@ -185,5 +185,5 @@
     for (uint32_t i=0; i<_param._nb_update; i++)
       {
-	string update_address;
+	std::string update_address;
 
 	if (_param._size_table>1)
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_testbench_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Generic/Victim/Victim_Pseudo_LRU/src/Victim_Pseudo_LRU_vhdl_testbench_transition.cpp	(revision 68)
+++ 	(revision )
@@ -1,31 +1,0 @@
-#ifdef VHDL_TESTBENCH
-/*
- * $Id$
- *
- * [ Description ]
- * 
- */
-
-#include "Behavioural/Generic/Victim/Victim_Pseudo_LRU/include/Victim_Pseudo_LRU.h"
-
-namespace morpheo {
-namespace behavioural {
-namespace generic {
-namespace victim {
-namespace victim_pseudo_lru {
-
-
-  void Victim_Pseudo_LRU::vhdl_testbench_transition (void)
-  {
-    // Evaluation before read the ouput signal
-//     sc_start(0);
-
-    _interfaces->testbench();
-  };
-
-}; // end namespace victim_pseudo_lru
-}; // end namespace victim
-}; // end namespace generic
-}; // end namespace behavioural
-}; // end namespace morpheo              
-#endif
